' Collapse-ifier using collapse effects determination pp109-191 of TNE
' Again, this uses the sector files from ftp.ghost.cc.missouri.edu
' This creates a new sector file, xxxxx_cl of the same format
DECLARE FUNCTION dieroll! (ds AS INTEGER, num AS INTEGER)
DECLARE FUNCTION tonum! (A AS STRING)
RANDOMIZE TIMER
CLEAR , , 1000
INPUT "Sector to crash"; file$
ofile$ = LEFT$(file$, 5) + "_CL"
OPEN file$ FOR INPUT AS #1
OPEN ofile$ FOR APPEND AS #2
DO
LINE INPUT #1, data$
uwp$ = MID$(data$, 20, 9)'get UWP code from string
pm$ = MID$(data$, 52, 1)' get pop multiplier
sz$ = MID$(uwp$, 2, 1)
bse$ = MID$(data$, 31, 1)' get military base type
SELECT CASE sz$ ' deal with oddball (non 0-F0 worlds...they all get depopulated anyway)
        CASE "R", "S"
        szf$ = "0"
        CASE "SGG", "LGG"
        szf$ = "F"
        CASE ELSE
        szf$ = sz$
END SELECT
sz = tonum(szf$)'get size
atm = tonum(MID$(uwp$, 3, 1)) 'get atmosphere
hyd = tonum(MID$(uwp$, 4, 1)) ' hydrosphere
pop = tonum(MID$(uwp$, 5, 1)) ' population
gov = tonum(MID$(uwp$, 6, 1)) ' government level
law = tonum(MID$(uwp$, 7, 1)) ' law level
tech = tonum(MID$(uwp$, 9, 1))' tech level
sp$ = MID$(uwp$, 1, 1)
IF sp$ = "X" THEN sp$ = "0"' temp change to 0 for no base
sp = tonum(sp$)
pmul = tonum(pm$)'get pop multiplier
' now calculate the new values
' get max sustainable population
npop = pop
SELECT CASE atm
        CASE IS <= 3 'atm 0-3 or > A cannot support life unaided
        npop = 0
        CASE IS >= 11
        npop = 0
        CASE 5, 7, 9
        npop = pop - 1
        CASE 4
        npop = pop - 2
END SELECT
SELECT CASE sz
        CASE IS <= 4
        npop = pop - 2
        CASE 5 TO 7
        npop = pop - 1
END SELECT
SELECT CASE hyd
        CASE 1, 2, 11
        npop = pop - 1
        CASE 0
        npop = pop - 2
END SELECT
' do tech level decline
SELECT CASE tech
        CASE IS <= 8
        ntech = tech - (dieroll(6, 1) - 3)
        CASE 9 TO 11
        ntech = tech - dieroll(6, 1)
        CASE 12 TO 14
        ntech = tech - dieroll(6, 2)
        CASE IS >= 15
        ntech = tech - dieroll(6, 3)
END SELECT
IF ntech < 0 THEN ntech = 0' yet another bounding condition
'calculate actual population
tloss = CINT((tech - ntech) / 4)
IF ntech = 0 THEN tloss = CINT(tech / 4)'if current tech is 0 then you lost everything
npmul = pmul - tloss
IF npmul < 1 THEN
        npmul = 9 - ABS(npmul)
        npop = npop - 1
END IF
' do low population effects
IF npop <= 5 THEN
        ntech = ntech - 1
        IF npmul = 1 THEN
        npop = npop - 1
        npmul = 5
        ELSE
        npmul = INT(npmul / 2)
        END IF
END IF
IF ntech < 0 THEN ntech = 0
' Check starport
tloss = tech - ntech
IF ntech = 0 THEN tloss = tech
chroll = dieroll(6, 1)
SELECT CASE (chroll - tloss)
        CASE IS > 0
        nsp = sp + 1 'starports rank from A high to E low, this is a hex #
        CASE IS = 0
        nsp = sp + 2' so have to add to make it go 'lower'
        CASE IS < 0
        nsp = 0
END SELECT
IF nsp > 14 THEN nsp = 0 ' only starports abcde x
IF nsp < 11 THEN nsp = 0
' Determine Government code
'there's no spot in the coding to indicate a balkanized world
'so I'll just determine that if and when the people arrive there
tloss = tech - ntech
IF ntech = 0 THEN tloss = tech
govroll = dieroll(10, 1)
IF (npop >= 5) AND (govroll < tloss) THEN
        ngov = 6
ELSE
        ngov = dieroll(6, 2) - 7 + npop
END IF
IF ngov < 0 THEN ngov = 0
' now determine new law level
lawroll = dieroll(6, 2) - 7
IF ngov = 6 THEN
        nlaw = lawroll + ngov + 4
ELSE
        nlaw = lawroll + ngov
END IF
IF nlaw < 0 THEN nlaw = 0
' determine mil bases
SELECT CASE (sp - nsp)
        CASE IS > 2
                nbse$ = " " ' destroyed
        CASE IS = 1
                bsesurv = dieroll(10, 1)
                SELECT CASE bse$
                CASE "N", "Z", "M"' treat Naval, Zhodani, Non-Imp Mil bases equal
                        IF bsesurv >= 9 THEN
                                nbse$ = bse$
                        ELSE
                                NSBE$ = " "
                        END IF
                CASE "S"' Scout base
                        IF bsesurv >= 8 THEN
                                nbse$ = bse$
                        ELSE
                                nbse$ = " "
                        END IF
                CASE "A"' Naval and Scout base
                        IF bsesurv >= 9 THEN
                                nbse$ = bse$
                        ELSEIF bsesurv = 8 THEN
                                nbse$ = "S" ' only scout survived
                        ELSE nbse$ = " " ' All gone
                        END IF
                CASE ELSE ' everything else
                        IF bsesurv = 10 THEN
                                nbse$ = bse$
                        ELSE
                                nbse$ = " "
                        END IF
                END SELECT

        CASE ELSE
                IF nsp = 0 THEN
                        nbse$ = " " 'No starport, no base
                ELSE
                        nbse$ = bse$
                END IF
        END SELECT
'Now rebuild the data line New uwp, bases, pop multiplier
IF nsp <= 0 THEN
        nsp$ = "X"
ELSE
        nsp$ = HEX$(nsp)
END IF
IF npop <= 0 THEN
npop$ = "0"
ELSE
npop$ = HEX$(npop)
END IF
SELECT CASE (nlaw)
CASE 0 TO 16
        nlaw$ = HEX$(nlaw) ' law level 0-E
CASE IS > 16
        nlaw$ = CHR$(69 + (nlaw - 16))' law level F-L
CASE ELSE
        nlaw$ = "0"
END SELECT
IF npop$ = "0" THEN nlaw$ = "0"
ngov$ = HEX$(ngov)
IF npop$ = "0" THEN ngov$ = "0"
ntech$ = HEX$(ntech)' nobody's greater than F anyway!
IF npop$ = "0" THEN ntech$ = "0"
hyd$ = MID$(uwp$, 4, 1)' get right values back
atm$ = MID$(uwp$, 3, 1)
npm$ = STR$(npmul)'between 1 and 9
nuwp$ = nsp$ + sz$ + atm$ + hyd$ + npop$ + ngov$ + nlaw$ + "-" + ntech$
ndata$ = LEFT$(data$, 19) + nuwp$ + SPACE$(22) + npm$ + MID$(data$, 53, 2) + " Wi"
PRINT #2, ndata$
LOOP UNTIL (EOF(1))
CLOSE #2
CLOSE #1
END

FUNCTION dieroll (ds AS INTEGER, num AS INTEGER)
dr = 0
FOR i = 1 TO num
dr = dr + (INT(RND * ds) + 1)
NEXT i
dieroll = dr
END FUNCTION

FUNCTION tonum (A AS STRING)
SELECT CASE A
        CASE IS = "F"
        tonum = 16
        CASE IS = "E"
        tonum = 15
        CASE IS = "D"
        tonum = 14
        CASE IS = "C"
        tonum = 13
        CASE IS = "B"
        tonum = 12
        CASE IS = "A"
        tonum = 11
        CASE ELSE
        tonum = VAL(A)
END SELECT

END FUNCTION

