'Sectmass, sector massager,batchfile atlas making version
'Copyright 1995 Bruce Johnson
'This program is freely distributable in unmodified form
'If you like it, use it, it works for me
'This program takes the sector files from the traveller/sectors/dgp-sectors directory at
' ftp.ghost.cc.missouri.edu and creates subsector files for the program sub2ps, which is at the
'old trav site at ftp.engrg.uwo.ca  This is a really nice program, but is avaliable only as C source.
'I know sub2ps works fine on a unix box, which is where I run it.
'However all I know is BASIC...so this is the code to be run on whatever system you can use it on
'It is officially written in qbasic from MS-DOS 6.22, which is equivalent to quickbasic 4.5, I believe except for compilation functions
'But it's pretty straightforward and should be adaptable to run under just about any flavor of BASIC
'
dr$ = "BIGLIST.TXT"' this version will do all the sectors in biglist.txt
'Biglist has the format: filename,sector name, cw sector, rw sector, sw sector, tw sector
'Biglist is part of the distribution.  Warning this will create a LOT of files...16 for each sector 
'
'if desired, the first section could easily be converted into an interactive session for doing single sectors, or subsectors
'NOTE: The thirteen line headers have to be edited off of the original sector files.
'
OPEN dr$ FOR INPUT AS #1
	DO
		INPUT #1, fil$, nm$, cw$, rw$, sw$, asw$
		REM Fil$=File name, nm$= sector name, cw$,rw$,sw$ asw$ neighbor sectors
FOR i = 1 TO 16
		IF i < 10 THEN
			ofil$ = fil$ + ".0" + LTRIM$(STR$(i))' for some reason, the str$ function on an integer produces a space at the beginning of the string in qbasic and quick basic 4.5
		ELSE
			ofil$ = fil$ + "." + LTRIM$(STR$(i))
		END IF
		OPEN ofil$ FOR APPEND AS #3
			PRINT #3, "!title," + nm$ +" subsector # " + STR$(i)
			IF RIGHT$(fil$, 3) = "_CL" THEN
				PRINT #3, "!subtitle," + sext$ + "N.E. Data"
			ELSE
				PRINT #3, "!subtitle," + sext$ + "Imperial Data Service"
			END IF
			ssec% = i
			SELECT CASE ssec%
				CASE 1 TO 4
				cwl$ = cw$ + " " + CHR$(64 + ssec% + 12)' give it standard A-P sector nomenclature
				CASE ELSE
				cwl$ = nm$ + " " + CHR$(64 + ssec% - 4)
			END SELECT
			SELECT CASE ssec%
				CASE 13 TO 16
				rwl$ = rw$ + " " + CHR$(64 + ssec% - 12)
				CASE ELSE
				rwl$ = nm$ + " " + CHR$(64 + ssec% + 4)
			END SELECT
			SELECT CASE ssec%
				CASE 1, 5, 9, 13
				swl$ = sw$ + " " + CHR$(64 + ssec% + 3)
				CASE ELSE
				swl$ = nm$ + " " + CHR$(64 + ssec% - 1)
			END SELECT
			SELECT CASE ssec%
				CASE 4, 8, 12, 16
				aswl$ = asw$ + " " + CHR$(64 + ssec% - 3)
				CASE ELSE
				aswl$ = nm$ + " " + CHR$(64 + ssec% + 1)
			END SELECT
			PRINT #3, "!adjacent,t," + cwl$
			PRINT #3, "!adjacent,b," + rwl$
			PRINT #3, "!adjacent,l," + swl$
			PRINT #3, "!adjacent,r," + aswl$
			CLOSE #3
	NEXT i
LOOP UNTIL (EOF(1))
CLOSE #1
	OPEN dr$ FOR INPUT AS #1
	DO
		INPUT #1, fil$, nm$, cw$, rw$, sw$, asw$
		REM Fil$=File name, nm$= sector name, cw$,rw$,sw$ asw$ neighbor sectors
	OPEN fil$ FOR INPUT AS #2
		DO
		LINE INPUT #2, data$ 'data string from standard sector datafile
		hx% = VAL(MID$(data$, 15, 4))'get hex number
		ssec% = ((hx% \ 100) - 1) \ 8 + 1 + (((hx% MOD (100)) - 1) \ 10) * 4' get subsector number
		' Thanks to Travis McCord; I swiped this algorithm from sub2ps ;-)
		IF ssec% < 10 THEN
			ofil$ = fil$ + ".0" + LTRIM$(STR$(ssec%))' for some reason, the str$ function on an integer produces a space at the beginning of the string in qbasic and quick basic 4.5
		ELSE
			ofil$ = fil$ + "." + LTRIM$(STR$(ssec%))
		END IF
		plan$ = RTRIM$(LEFT$(data$, 13))'trim trailing spaces
		IF plan$ = "" THEN plan$ = "---no name" ' I don't know if sub2ps handles null items
		mdat$ = plan$ + "," + MID$(data$, 15, 4) + "," + MID$(data$, 20, 9) + " " + MID$(data$, 31, 1) + " "
		IF RIGHT$(ofil$, 3) <> "_CL" THEN
			IF MID$(data$, 49, 1) = " " THEN ' set travel zone
			 tz$ = "G"
			ELSE
			 tz$ = MID$(data$, 49, 1)
			END IF
		ELSE
			tz$ = " "
		END IF
		IF RIGHT$(ofil$, 3) <> "_CL" THEN mdat$ = mdat$ + tz$ + MID$(data$, 52, 3) + MID$(data$, 56, 2) + "," + MID$(data$, 33, 15)
		OPEN ofil$ FOR APPEND AS #3
		PRINT #3, mdat$
		CLOSE #3
	LOOP UNTIL (EOF(2))
	CLOSE #2
	LOOP UNTIL (EOF(1))
CLOSE #1
END


